%% priklad 12
clear;

%% parametry signalu
A = 1.0;
a = 0.7;


%% volba fsa: spektralne neomezeny signal, cim vetsi, tim lepsi
%tmax = 25.0;
%tmax = 25.0;
tmax = 100.0;
%N = 20;
%N = 50;
%N = 200;
N = 2e3;
cast=linspace(-tmax,tmax,N);
Tsa = cast(2)-cast(1);
fsa = 1/Tsa;
fprintf(1, 'omega_sa/2: %f\n', 2*pi*fsa/2);

%% vytvoreni signalu
signal = A*exp(-a*abs(cast));

figure(1);clf;
plot(cast, signal, 'b-x');
xlabel('t');
ylabel('s(t)');


%% analyticky tvar spektra
ommax = 10;
omega = linspace(-ommax,ommax,200);
SpekAnl = 2*a*A./(a^2+omega.^2);

%% vypocet spektra: 
SpekDFT = Tsa*fft(signal);
NDFT = length(SpekDFT);

%% zobrazeni spektra
figure(2);clf;
plot(0:NDFT-1, abs(SpekDFT), 'b-o');
xlabel('\omega');
ylabel('|S(\omega)|');

%% zobrazeni spektra -- fftshift()
figure(3);clf;
plot(omega, abs(SpekAnl),'r-x');
hold on;
plot(((0:NDFT-1)-fix(NDFT/2))*(2*pi*fsa)/NDFT, fftshift(abs(SpekDFT)),'b-o');
xlabel('\omega');
ylabel('|S(\omega)|');
