%% vypocet komplexni obalky 

clear;
close all; % deletes all figures whose handles are not hidden

load('signal_BP_4.mat');
% nacteno: fo, fsa, signal
%
% obnoveni ostatnich parametru
N1 = length(signal);
Tsa = 1/fsa;
caso = (0:N1-1)*Tsa;

% interval pro zobrazeni casovych useku
interval = (1:512)+1e3;

%%----------------------------------------------------------------------------
%% zpusob 1: Operace ve spektralni oblasti
% f-ce hilbert() -- pomoci fft() vytvori analyticky signal
sig_A = hilbert(signal);
sig_CE = sig_A.*exp(-1j*2*pi*fo*caso);

%--filtr, ktery potlaci sum AWGN
b1 = firpm(51, [0 0.05 0.1 1],[1 1 0 0]);
sig_CE = filter(b1,1,sig_CE);

figure(1);clf;hold on;
title('CE -- operace ve spektralni oblasti');
plot(real(sig_CE), imag(sig_CE), 'b:o');

figure(2);clf;hold on;
title('CE -- operace ve spektralni oblasti');
plot(caso(interval), real(sig_CE(interval)), 'b-o');
plot(caso(interval), imag(sig_CE(interval)), 'r-x');

%%----------------------------------------------------------------------------
%% zpusob 2: filtracni metoda
sig_ref = signal.*cos(2*pi*fo*caso);
sig_imf = -signal.*sin(2*pi*fo*caso);

% filtr
% firpm(n, f, a), kde n je rad filtru, vrati n+1 koef; 
% skup zpozdeni je (n+1)/2
b = firpm(31, [0 0.05 0.1 1],[1 1 0 0]);
sig_re = filter(b,1,sig_ref);
sig_im = filter(b,1,sig_imf);

figure(5);clf;hold on;
title('CE -- filtracni metoda');
plot(sig_re(100:end), sig_im(100:end), 'b:o');

figure(6);clf;hold on;
title('CE -- filtracni metoda');
plot(caso(interval), sig_re(interval), 'b-o');
plot(caso(interval), sig_im(interval), 'r-x');

%figure(7);clf;hold on;
%pwelch(signal);
%pwelch(sig_re);

%%----------------------------------------------------------------------------
%% zpusob 3: pres Hilbertovu transformaci
% navrh hilbertova transfromatoru
rad_f = 30; %rad filtru
b = firpm(rad_f,[0.1 0.9],[1 1], 'hilbert');

%filtr, ktery bude delat odpovidajici zpozdeni k hilb transf
% funkce fix() je jen pro jistotu, kdyby Hilb. trans byl navrzen blbe, aby 
% to neskoncilo chybou
clear('bz'); bz( fix(rad_f/2) ) = 1;

sig_AA = filter(bz,1,signal)+1j*filter(b,1,signal);
sig_CEE = sig_AA.*exp(-1j*2*pi*fo*caso);

figure(11);clf;hold on;
title('CE -- pomoci Hilb. transf.');
plot(real(sig_CEE), imag(sig_CEE), 'b:o');

figure(12);clf;hold on;
title('CE -- pomoci Hilb. transf.');
plot(caso(interval), real(sig_CEE(interval)), 'b-o');
plot(caso(interval), imag(sig_CEE(interval)), 'r-x');

figure(10);clf;
[HH, ww] = freqz(b,1,512,'whole');
FL = length(ww)
plot(ww/2/pi, angle( HH.*exp( 1j*ww*rad_f/2 ) )/pi );
xlabel('\Omega/2\pi');ylabel('arg(H(\Omega))/\pi');
title('fazova char. Hilb. transf. po korekci');


%figure(15);clf;
%pwelch(sig_CEE);
