%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CZS cv. 10
% vztah komplexni obalky (CE) a pasmoveho signalu (BP)

clear;

%% parametry signalu
% pocet stavu modulace, postupne zkuste 2,4,8
M = 8;
% vykon pasmoveho signalu bez sumu (vykon komplexni obalky je 2*P)
P = 1;
% pomer vykon sigbalu ku spektralni vykonove hustote (v [dB-Hz])
P_No_dB = 53;
% vzorkovaci kmitoce / perioda
fsa = 55e3;
    Tsa = 1/fsa;
% symbolova rychlost, doba trvani symbolu
fs = 1e3;
    Ts = 1/fs;
% pocet symbolu, se kterymi budeme pracovat
Ns = 100;
    N = fix(Ns*Ts/Tsa);
% kmitocet nosne: stred pasma pasmoveho signalu
fo = 10e3;

% po doplneni nasledujici casti posunout 'return' na jeji konec
return; 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Cast -- A1

%% generovani stejne pravdepodobnych nezavislych symbolu
symbl = XXX

s_CE = XXX

%% zobrazeni
figure(1);clf;
subplot(311);
plot( (0:N-1)*Tsa, real(s_CE), 'b');
hold on;
plot( (0:N-1)*Tsa, imag(s_CE), 'g');
xlabel('t [s]');
legend('In-phase','Quadrature');
title('CE without noise');

subplot(312);
plot(real(s_CE), imag(s_CE), 'x:' );
axis([-1.2,1.2,-1.2,1.2]);
xlabel('I(t)'); ylabel('Q(t)');
title('CE in complex plain');

subplot(313);
[PP, ww] = pwelch(s_CE,5*fix(Ts/Tsa),[],[],fsa,'twosided');
plot(ww - ww(fix(length(ww)/2)+1), 10*log10( fftshift(PP) ) ); 
grid on;
set(gca,'YLim',[-70,-20]);
xlabel('f [Hz]');
title('PSD of CE without noise [dB/Hz]');

%% pro kontrolu, vypoctete vykon s_CE v casove a/nebo spek. oblasti
P_CE_time = XXX
P_CE_freq = XXX


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Cast -- A2

% No -- PSD soufazove nebo kvadraturni slozky
No = XXX

% jaky ma byt vykon soufazove nebo kvadraturni slozky, kdyz kazda ma mit
% oboustrannou PSD = No ?
n_CE = XXX

%% vypoctete vykon sumu (vykon n_CE)
XXX

%% navrh filtru DP
% filtr meni vykon sumu, ale nemeni PSD ve zpracovavanem pasmu
b1=firpm(40, XXX, XXX);

% varianta: komplexni obalka s filtrovanym/nefiltrovanym sumem
sn_CE = s_CE + n_CE;
%sn_CE = filter(b1,1, s_CE + n_CE);


%% zobrazeni
figure(2);clf;
subplot(311);
plot( (0:N-1)*Tsa, real(sn_CE), 'b');
hold on;
plot( (0:N-1)*Tsa, imag(sn_CE), 'g');
xlabel('t [s]');
legend('In-phase','Quadrature');
title('CE with AWGN');

subplot(312);
plot(real(sn_CE), imag(sn_CE), 'x:' );
axis([-2.5,2.5,-2.5,2.5]);
xlabel('I(t)'); ylabel('Q(t)');
title('CE in complex plain');

subplot(313);
[PP, ww] = pwelch(sn_CE,5*fix(Ts/Tsa),[],[],fsa,'twosided');
plot(ww - ww(fix(length(ww)/2)+1), 10*log10( fftshift(PP) ) ); 
set(gca,'YLim',[-70,-20]);
grid on; hold on;
plot(ww - ww(fix(length(ww)/2)+1), ones(length(PP),1)*10*log10(2*No),'r-');
xlabel('f [Hz]');
title('PSD of CE with AWGN [dB/Hz]');
legend('signal PSD', 'AWGN PSD: 2*No');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% CAST -- B

% POZOR: pred prevodem CE->BP je potreba zajistit, aby spektrum sn_CE
% bylo nulove pro |f| > fo. Bud lze pouzit dostatecne uzky filtr
% z predchoziho kroku, nebo znovu filtrovat.
% Nedodrzeni podminky: nesedi predpoklady o PSD sumu 2*No u CE a No/2
% u BP, viz PSD v okolu nuly.

b2=firpm(40, XXX, XXX);
sn_CE = filter(b2, 1, sn_CE);

%% prevod CE -> BP
sn_BP = XXX


%% uloznei BP do souboru:
% v ramci domaciho cviceni lze pak pouzit k prevodu BP->CP jinou 
% metodou (pomoci Hilbertova transformatoru, prevod ve frekvencni
% oblasti)
save('sn_BP.mat','sn_BP');

%% zobrazeni
figure(3);clf;
subplot(211);
plot( (0:N-1)*Tsa, sn_BP, 'b');
xlabel('t [s]');
title('BP in time domain');

subplot(212);
[PP, ww] = pwelch(sn_BP,5*fix(Ts/Tsa),[],[],fsa,'twosided');
plot(ww - ww(fix(length(ww)/2)+1), 10*log10( fftshift(PP) ) ); 
set(gca,'YLim',[-70,-30]);
grid on; hold on;
plot(ww - ww(fix(length(ww)/2)+1), ones(length(PP),1)*10*log10(No/2),'r-');
xlabel('f [Hz]');
title('PSD of BP');
legend('signal PSD', 'AWGN PSD: No/2');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% CAST -- C

%% prevod BP -> CE filtracni metodou

sn_I2 = XXX
sn_Q2 = XXX

sn_CE2 = sn_I2 + 1j*sn_Q2;

%% zobrazeni
figure(4);clf;
subplot(311);
plot( (0:N-1)*Tsa, real(sn_CE2), 'b');
hold on;
plot( (0:N-1)*Tsa, imag(sn_CE2), 'g');
legend('In-phase','Quadrature');
title('final CE');

subplot(312);
plot(real(sn_CE2), imag(sn_CE2), 'x:' );
axis([-2.5,2.5,-2.5,2.5]);
xlabel('I(t)'); ylabel('Q(t)');
title('final CE in complex plain');

subplot(313);
[PP, ww] = pwelch(sn_CE2,5*fix(Ts/Tsa),[],[],fsa,'twosided');
plot(ww - ww(fix(length(ww)/2)+1), 10*log10( fftshift(PP) ) ); 
grid on;
xlabel('f [Hz]');
title('PSD of final CE [dB/Hz]');
set(gca,'YLim',[-70,-20]);
grid on; hold on;
plot(ww - ww(fix(length(ww)/2)+1), ones(length(PP),1)*10*log10(2*No),'r-');
xlabel('f [Hz]');
legend('signal PSD', 'AWGN PSD: 2*No');

