close all
clear all

% Obdelnik - spojity neperiodicky

A=5;
to=0.04 ;   % to = 40 ms ;

% Zobrazeni v rozsahu -0.1 az 0.4 s

t1=-0.1:0.0001:0.5 ;   

s1=A.*( (t1<=to) & (t1>=0) ) ;

figure(1)
subplot(221)
plot(t1,s1);
axis([min(t1) max(t1) min(s1)-0.05*(max(s1)-min(s1)) max(s1)+0.05*(max(s1)-min(s1))]) ;
xlabel('t [s]')
ylabel('s(t)')
title('Spojity neperiodicky signal')
grid

pause

% Vypocet spektra v rozsahu -w_max az +w_max

wmax=3000;
w1=-wmax:wmax;
S1 = A.*(exp(j*to*w1)-1)./j./w1;

subplot(222)
plot(w1,abs(S1));
xlabel('\omega [rad/s]')
ylabel('|S(\omega)|')
title('FT spojiteho neperiodickeho signalu')
grid

pause

% Vzorkovani vyse uvedeneho signalu
% Volba: fs1 ... vzorkovaci kmitocet
%        td1 ... delka zaznamu (z toho se pak spocita pocet vzorku) 

td1=0.4;    %   Menit delku zaznamu  td1 = 0.8, 0.4, 0.11,  0.08,   0.035
fs1=200 ;    %   Menit vzorkovaci kmitocet fs1 = 1500, 820, 500, 200, ...

Ts1=1/fs1;
ts1=0:Ts1:td1;
ss1=A.*( (ts1<=to) & (ts1>=0) ) ;
N1=length(ss1);
df1= fs1/N1;
SS1=fft(ss1);

% zobrazeni samotneho navzrokovaneho signalu


subplot(223)
plot(ts1,ss1,'r.')
% axis([min(ts1) max(ts1) min(ss1)-0.05*max((max(ss1)-min(ss1)),0.01) max(ss1)+0.05*max((max(ss1)-min(ss1)),0.01)]) ;
xlabel('t [s]')
ylabel('ss(t)')
title('Vzorky spojiteho neperiodickeho signalu')

% zobrazeni spocitaneho DFT spektra 

pause

subplot(224);
plot(abs(SS1),'r.:')
title('DFT navzorkovane casti signalu')
xlabel('k')
ylabel('|S[k]|')


% Zobrazeni navzorkovane casti signalu do puvodniho signalu

pause

subplot(221)
hold on
plot(ts1,ss1,'r.');
hold off


% Prepocet DFT spektra a zobrazeni do puvodniho teoreticky spocitaneho
% spektra

pause

subplot(222)
hold on
SSS1=Ts1.*fftshift(SS1);
ws1=2*pi*(-fs1/2+df1:df1:fs1/2);       % Zde je to trochu posunute
ws1=2*pi*((0:N1-1)-fix(N1/2))*fs1/N1;  % Toto je centrovana varianta vzhledem k nulove frekvenci

plot(ws1,abs(SSS1),'r.:');
hold off

