%  cv3_dft_basic  - basic properties of DFT periodogram

if exist('/etc/init.d'),
    % For linux
    addpath /home/pollak/www/html/vyu/b2m31czs/m
    addpath /home/pollak/www/html/vyu/b2m31czs/signaly
else
    % For windows
    if exist('H:\VYUKA\CZS')
        addpath H:\VYUKA\CZS\m; 
        addpath H:\VYUKA\CZS\signaly; 
    else
        addpath C:\usr\pollak\www\html\vyu\b2m31czs\m
        addpath C:\usr\pollak\www\html\vyu\b2m31czs\signaly
    end
end


%% DFT of sinusoid

A=1;
f=1000;
fs=8000;
tmax=1;

tt=0:1/fs:tmax;
s1=sin(2*pi*f*tt);

N=512;
S1=fft(s1(1:N)); 
S1abs = abs(S1);

h=figure(1);  set(h,'Name','Basic DFT spectrum of sinusoid')
ff=(0:N-1).*fs./N ;

subplot(211)

plot(ff,S1abs);
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

subplot(212)

stem(ff,S1abs);
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])



h=figure(2);  set(h,'Name','DFT spectrum of sinusoid - spectral leackage')


N=512;
ff=(0:N-1).*fs./N ;
S1abs=abs(fft(s1(1:N)));

subplot(311)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=510;
ff=(0:N-1).*fs./N ;
S1abs=abs(fft(s1(1:N)));

subplot(312)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=508;
ff=(0:N-1).*fs./N ;
S1abs=abs(fft(s1(1:N)));

subplot(313)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])


h=figure(3);  set(h,'Name','DFT spectrum of sinusoid - spectral leackage')


N=512;
ff=(0:N-1).*fs./N ;
S1abs=abs(fft(s1(1:N)));

subplot(311)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=515;
ff=(0:N-1).*fs./N ;
S1abs=abs(fft(s1(1:N)));

subplot(312)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=520;
ff=(0:N-1).*fs./N ;
S1abs=abs(fft(s1(1:N)));

subplot(313)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])



h=figure(4);  set(h,'Name','DFT spectrum of sinusoid - spectral leackage, Hamming window')


N=512;
ff=(0:N-1).*fs./N ;
wn=hamming(N);
S1abs=abs(fft(s1(1:N).*wn'));

subplot(311)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=510;
ff=(0:N-1).*fs./N ;
wn=hamming(N);
S1abs=abs(fft(s1(1:N).*wn'));

subplot(312)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=508;
ff=(0:N-1).*fs./N ;
wn=hamming(N);
S1abs=abs(fft(s1(1:N).*wn'));

subplot(313)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])


h=figure(5);  set(h,'Name','DFT spectrum of sinusoid - spectral leackage, Hamming window')


N=512;
ff=(0:N-1).*fs./N ;
wn=hamming(N);
S1abs=abs(fft(s1(1:N).*wn'));

subplot(311)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=515;
ff=(0:N-1).*fs./N ;
wn=hamming(N);
S1abs=abs(fft(s1(1:N).*wn'));

subplot(312)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=520;
ff=(0:N-1).*fs./N ;
wn=hamming(N);
S1abs=abs(fft(s1(1:N).*wn'));

subplot(313)
stem(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  General sinusoid
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

f=1231 ;
s1=sin(2*pi*f*tt)+0.5*randn(1,length(tt));

h=figure(6);  set(h,'Name','DFT spectrum of GENERAL sinusoid - spectral leackage')


N=512;
ff=(0:8*N-1).*fs./(8*N) ;
S1abs=abs(fft(s1(1:N),8*N));

subplot(311)
plot(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=515;
ff=(0:N-1).*fs./N ;
S1abs=abs(fft(s1(1:N)));

subplot(312)
plot(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=520;
ff=(0:N-1).*fs./N ;
S1abs=abs(fft(s1(1:N)));

subplot(313)
plot(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])


h=figure(7);  set(h,'Name','DFT spectrum of GENERAL sinusoid - spectral leackage, Hamming window')


N=512;
ff=(0:8*N-1).*fs./(N*8) ;
wn=hamming(N);
S1abs=abs(fft(s1(1:N).*wn',8*N));

subplot(311)
plot(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=515;
ff=(0:N-1).*fs./N ;
wn=hamming(N);
S1abs=abs(fft(s1(1:N).*wn'));

subplot(312)
plot(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

N=520;
ff=(0:N-1).*fs./N ;
wn=hamming(N);
S1abs=abs(fft(s1(1:N).*wn'));

subplot(313)
plot(ff,S1abs,'.-');
xlabel('f [Hz]');
ylabel('Sabs');
title(['Sinusoid - DFT spectrum: f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz, NFFT=' num2str(N)])

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Periodogram of speech signal
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sp=loadbin('vm7.bin');
fs=16000;

h=figure(10);  set(h,'Name','Waveform of speech signal')
plot(sp)

N=512;
wn=hamming(N);
spf=sp(1:N);

h=figure(11);  set(h,'Name','DFT spectrum of speech signal - SPEKTRAL LEACKAGE')

N=512;
wn=hamming(N);
spf=sp(1:N);
 
subplot(221)
plot(spf);
title('Unweighted frame')

Spfdb=10*log10(abs(fft(spf)).^2/N);

subplot(222)
ff=(0:N/2-1).*fs./N ;
plot(ff,Spfdb(1:N/2));
title('DFT - spectral leackage')

subplot(223)
plot(spf.*wn);
title('Weighted frame')

Spfdb=10*log10(abs(fft(spf.*wn)).^2/N);

subplot(224)
ff=(0:N/2-1).*fs./N ;
plot(ff,Spfdb(1:N/2));
title('DFT - minimized leackage')


