% Cviceni 3 - detekce periodicity

if exist('/etc/init.d'),
    % For linux
    addpath /home/pollak/www/html/vyu/b2m31czs/m
    addpath /home/pollak/www/html/vyu/b2m31czs/signaly
else
    % For windows
    if exist('H:\VYUKA\CZS')
        addpath H:\VYUKA\CZS\m; 
        addpath H:\VYUKA\CZS\signaly; 
    else
        addpath C:\usr\pollak\www\html\vyu\b2m31czs\m
        addpath C:\usr\pollak\www\html\vyu\b2m31czs\signaly
    end
end



%% 

fs=16000 ;
ss1=loadbin('vm0-1-per.bin');
ss2=loadbin('vm0-2-per.bin');
ss3=loadbin('vm0-3-per.bin');
ss4=loadbin('vm0-4-per.bin');

figure(1)
subplot(221);  plot(ss1) ; title('Signal frame with 1 period')
subplot(222);  plot(ss2) ; title('Signal frame with 2 periods')
subplot(223);  plot(ss3) ; title('Signal frame with 3 periods')
subplot(224);  plot(ss4) ; title('Signal frame with 4 periods')


figure(2)
subplot(221);  plot(abs(fft(ss1)),'.-') ; xlim([0 length(ss1)/4]) ; title('Spectrum of frame with 1 period')
subplot(222);  plot(abs(fft(ss2)),'.-') ; xlim([0 length(ss2)/4]) ; title('Spectrum of frame with 2 periods')
subplot(223);  plot(abs(fft(ss3)),'.-') ; xlim([0 length(ss3)/4]) ; title('Spectrum of frame with 3 periods')
subplot(224);  plot(abs(fft(ss4)),'.-') ; xlim([0 length(ss4)/4]) ; title('Spectrum of frame with 4 periods')

figure(3)
subplot(221);  plot(ss4) ;  title('Signal frame with 4 periods')
subplot(222);  plot(abs(fft(ss4,479)),'o-') ; xlim([0 length(ss4)/4]) ; title('Spectrum of the frame for NDFT=479')
subplot(223);  plot(abs(fft(ss4,490)),'o-') ; xlim([0 length(ss4)/4]) ; title('Spectrum of the frame for NDFT=490')
subplot(224);  plot(abs(fft(ss4,256)),'o-') ; xlim([0 length(ss4)/4]) ;  title('Spectrum of the frame for NDFT=256')


sss=loadbin('vm0-real-per.bin');

figure(4)
subplot(211);
plot(sss)
title('Analyzed periodic frame');

N=length(sss) ;   % Menit tez N=2*length(sss), 4*length(sss), 8*length(sss), ...
subplot(223)
ff=(0:N-1)./N*fs;
stem(ff,abs(fft(sss,N)),'.-')
xlim([0 3000])
title('Spectrum for NDFT=512');

N=4096 ;   % Menit tez N=2*length(sss), 4*length(sss), 8*length(sss), ...
subplot(224)
ff=(0:N-1)./N*fs;
stem(ff,abs(fft(sss,N)),'.-')
xlim([0 3000])
title('Spectrum for NDFT=4096');


ssu=loadbin('real-non-per.bin');

figure(5)
subplot(211);
plot(ssu)
title('Analyzed non-periodic frame');

N=length(ssu) ;   % Menit tez N=2*length(sss), 4*length(sss), 8*length(sss), ...
subplot(223)
ff=(0:N-1)./N*fs;
stem(ff,abs(fft(ssu,N)),'.-')
xlim([0 3000])
title('Spectrum for NDFT=512');

N=4096 ;   % Menit tez N=2*length(sss), 4*length(sss), 8*length(sss), ...
subplot(224)
ff=(0:N-1)./N*fs;
stem(ff,abs(fft(ssu,N)),'.-')
xlim([0 3000])
title('Spectrum for NDFT=4096');

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Periodogram of speech signal
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sp=loadbin('vm7.bin');
fs=16000;

h=figure(10);  set(h,'Name','Waveform of speech signal')
plot(sp)

N=512;
wn=hamming(N);
spf=sp(1:N);



NN=[2000 1024 512 256 128 64];

for i=1:6,
    N=NN(i);
    wn=hamming(N);
    spf=sp(1:N).*wn;
    Spfdb=10*log10(abs(fft(spf)).^2/N);

    h=figure(10+i);  
    
    subplot(211)
    plot(spf)
    xlim([0 length(spf)])
   
    subplot(212)
    ff=(0:N/2-1).*fs./N ;
    plot(ff,Spfdb(1:N/2));
   
    grid
    title(['Speech DFT spectrum N = ' num2str(N)])
    
end

%% ADDITIONAL WORK (HOMEWORK)



[sig1,fs]=audioread('cembalo_d_dur_2.wav');   instrument='cembalo';
[sig2,fs]=audioread('fletna_d_dur_6.wav');    instrument='flaute';
[sig3,fs]=audioread('housle_d_dur_5.wav');      instrument='violin';
[sig4,fs]=audioread('piano_d_dur_4.wav');     instrument='piano';
[sig5,fs]=audioread('varhany1_d_dur_3.wav');    instrument='organ 1';
[sig6,fs]=audioread('varhany2_d_dur_8.wav');    instrument='organ 2';

tlen=0.01 ;
wlen=floor(fs*tlen);
starttime=20000;

frame=zeros(wlen,6);
frame(:,1)=sig1(starttime+1:starttime+wlen);
frame(:,2)=sig2(starttime+1:starttime+wlen);
frame(:,3)=sig3(starttime+1:starttime+wlen);
frame(:,4)=sig4(starttime+1:starttime+wlen);
frame(:,5)=sig5(starttime+1:starttime+wlen);
frame(:,6)=sig6(starttime+1:starttime+wlen);

for ii=1:6,

figure(20+ii)
subplot(311)
plot(frame(:,ii))
title(['Signal - ' instrument])

subplot(312)
kk=-wlen+1:wlen-1 ;
plot(kk,xcorr(frame(:,ii),'biased'));
title('ACF')

subplot(313)
NDFT=4096;
Fabsdb=10*log10(abs(fft(frame(:,ii),NDFT)).^2);

ff=(0:NDFT/2-1).*fs./NDFT;
plot(ff,Fabsdb(1:NDFT/2));
title('Zero-padded amplitude spectrum')

end

