% B2M31CZS - Estimation of spectral characteristics for random and
% non-stationary signals
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fs=200;
tmax=20 ;

f1=14;
A1=0.5 ;

f2=27.5 ;
A2=0.43 ;


tt=0:1/fs:tmax-1/fs ;

s1=A1*sin(2*pi*f1*tt)+A2*sin(2*pi*f2*tt) ;

figure(1);
subplot(211)
plot(tt,s1) ;
title('Dve sinusovky')

subplot(212)
spectrogram(s1) ;
title('Implicitni nastaveni')

return



subplot(212)
wlen=256 ;
spectrogram(s1,wlen) ;
title(['wlen = ' num2str(wlen)])

pause

subplot(212)
wlen=256 ;
spectrogram(s1,wlen,'yaxis') ;
title(['Definice zobrazeni frekvence na y osy - parametr yaxis'])

pause


subplot(212)
wlen=256 ;
spectrogram(s1,hanning(wlen),'yaxis') ;
title(['Hanningovo okno: spectrogram(s,hanning(wlen))'])

pause


subplot(212)
wlen=256 ;
wstep=64 ;
% 4. parametr NFFT neni specifikovan - pouzije se wlen 
spectrogram(s1,wlen,wstep,[],fs,'yaxis') ;
title(['Specifikace vzorkovaciho kmitoctu'])

pause

figure(2)

[S1,F1,T1]=spectrogram(s1,wlen,[],[],fs,'yaxis') ;
plot(F1,abs(S1(:,1)));

pause


b1=randn(1,tmax*fs);

figure(3);
subplot(211)
plot(tt,b1) ;
title('Bily sum')


subplot(212)
wlen=256 ;
% wstep=128 ;
% 4. parametr NFFT neni specifikovan - pouzije se wlen 
spectrogram(b1,wlen,'yaxis') ;
title(['Spectrogram bileho sumu'])

pause

subplot(212)
wlen=1024 ;
% wstep=128 ;
% 4. parametr NFFT neni specifikovan - pouzije se wlen 
spectrogram(b1,wlen,'yaxis') ;
title(['Spectrogram bileho sumu'])


pause

subplot(212)
wlen=64 ;
% wstep=128 ;
% 4. parametr NFFT neni specifikovan - pouzije se wlen 
spectrogram(b1,wlen,'yaxis') ;
title(['Spectrogram bileho sumu'])


SNR=-3;
Ps1=mean(s1.*s1);
Pb1=mean(b1.*b1);
k=sqrt(Ps1/Pb1*exp(-SNR/10));
x1=s1+k*b1;

figure(4)
subplot(211)
plot(tt,x1);
subplot(212)
wlen=256 ;
spectrogram(x1,wlen,[],[],fs,'yaxis') ;
title(['Spectrogram smesi sinusovek a sumu'])


pause

e1=load('eeg.asc');
fs=200;

figure(5)
subplot(211)
tt=(1:length(e1))./fs ;
plot(tt,e1);
subplot(212)
wlen=256 ;
spectrogram(e1,wlen,[],[],fs,'yaxis') ;
title(['Spectrogram EEG'])


pause


r1=loadbin('sm2.bin');
r1=loadbin('sf2.bin');
r1=loadbin('sm1.bin');
r1=loadbin('sf1.bin');
fs=16000;

figure(6)
subplot(211)
tt=(1:length(r1))./fs ;
plot(tt,r1);
subplot(212)
wlen=512 ;
spectrogram(r1,wlen,[],[],fs,'yaxis') ;
title(['Spectrogram reci - wlen =' num2str(wlen)])

pause


wlen=256 ;
spectrogram(r1,wlen,[],[],fs,'yaxis') ;
title(['Spectrogram reci - wlen =' num2str(wlen)])

pause

wlen=128 ;
spectrogram(r1,wlen,[],[],fs,'yaxis') ;
title(['Spectrogram reci - wlen =' num2str(wlen)])

pause

wlen=1024 ;
spectrogram(r1,wlen,[],[],fs,'yaxis') ;
title(['Spectrogram reci - wlen =' num2str(wlen)])



pause

wlen=2048 ;
spectrogram(r1,wlen,[],[],fs,'yaxis') ;
title(['Spectrogram reci - wlen =' num2str(wlen)])


pause


wlen=512 ;
spectrogram(r1,hamming(wlen),[],[],fs,'yaxis') ;
title(['Spectrogram reci - hamming(512)'])

pause


wlen=512 ;
spectrogram(r1,hanning(wlen),[],[],fs,'yaxis') ;
title(['Spectrogram reci - hanning(512)'])
pause


wlen=512 ;
spectrogram(r1,rectwin(wlen),[],[],fs,'yaxis') ;
title(['Spectrogram reci - rectwin(512)'])

pause


wlen=512 ;
spectrogram(r1,blackman(wlen),[],[],fs,'yaxis') ;
title(['Spectrogram reci - blackman(512)'])

figure(7)
plot(abs(fft(r1)));
title('Nemozny vypocet spektra reci')





