% Design of IIR filters
%%%%%%%%%%%%%%%%%%%%%%%

fs=8000;
fc=800;
N=6;
Rp=3;
Rs=60 ;

disp('********************************')
disp('***    NAVRHY IIR FILTRU     ***')
disp('********************************')



Wc=fc/fs*2;
[b1,a1]=butter(N,Wc);
figure(1); freqz(b1,a1); 
title(['Butt : N=' num2str(N) ', fc=' num2str(fc) ', fs=' num2str(fs)])
[H1,ff]=freqz(b1,a1,1000,fs) ;

disp('-------------------------------')
disp(['Butt : N=' num2str(N) ', fc=' num2str(fc) ', fs=' num2str(fs)])
disp('-------------------------------')
disp(['a= ' num2str(a1)])
disp(['b= ' num2str(b1)])


[b2,a2]=cheby1(N,Rp,Wc);
figure(2); freqz(b2,a2); 
title(['Cheby1 : N=' num2str(N) ', fc=' num2str(fc) ', fs=' num2str(fs) ', Rp=' num2str(Rp)])
H2=freqz(b2,a2,1000,fs) ;

disp('-------------------------------')
disp(['Cheby1 : N=' num2str(N) ', fc=' num2str(fc) ', fs=' num2str(fs) ', Rp=' num2str(Rp)])
disp('-------------------------------')
disp(['a= ' num2str(a2)])
disp(['b= ' num2str(b2)])


[b3,a3]=cheby2(N,Rs,Wc);
figure(3); freqz(b3,a3); 
title(['Cheby2 : N=' num2str(N) ', fc=' num2str(fc) ', fs=' num2str(fs) ', Rs=' num2str(Rs)])
H3=freqz(b3,a3,1000,fs) ;

disp('-------------------------------')
disp(['Cheby2 : N=' num2str(N) ', fc=' num2str(fc) ', fs=' num2str(fs) ', Rs=' num2str(Rs)])
disp('-------------------------------')
disp(['a= ' num2str(a3)])
disp(['b= ' num2str(b3)])



[b4,a4]=ellip(N,Rp,Rs,Wc);
figure(4); freqz(b4,a4); 
title(['Ellip : N=' num2str(N) ', fc=' num2str(fc) ', fs=' num2str(fs) ', Rp=' num2str(Rp) ', Rs=' num2str(Rs)])
H4=freqz(b4,a4,1000,fs) ;

disp('-------------------------------')
disp(['Ellip : N=' num2str(N) ', fc=' num2str(fc) ', fs=' num2str(fs) ', Rp=' num2str(Rp) ', Rs=' num2str(Rs)])
disp('-------------------------------')
disp(['a= ' num2str(a4)])
disp(['b= ' num2str(b4)])


figure(5);
plot(ff,20*log10(abs(H1)),'b',ff,20*log10(abs(H2)),'r',ff,20*log10(abs(H3)),'g',ff,20*log10(abs(H4)),'m') ;
axis([0 fs/2 -80 0]);
% axis([500 1500 -80 0]);
% axis([0 500 -80 0]);
grid;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(6); impz(b1,a1) ;

figure(7); impz(b2,a2) ;

figure(8); impz(b3,a3) ;

figure(9); impz(b4,a4) ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(10); zplane(b1,a1) ;

figure(11); zplane(b2,a2) ;

figure(12); zplane(b3,a3) ;

figure(13); zplane(b4,a4) ;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


fs=8000;   % Try fs = 8000, 16000, 44100
fc1=300;
fc2=3400;
N=6;
Rp=0.5;
Rs=60 ;


Wc=[fc1/fs*2 fc2/fs*2];

[b1,a1]=butter(N,Wc);
[b2,a2]=cheby1(N,Rp,Wc);
[b3,a3]=cheby2(N,Rs,Wc);
[b4,a4]=ellip(N,Rp,Rs,Wc);

[H1,ff]=freqz(b1,a1,1000,fs) ;
[H2,ff]=freqz(b2,a2,1000,fs) ;
[H3,ff]=freqz(b3,a3,1000,fs) ;
[H4,ff]=freqz(b4,a4,1000,fs) ;

figure(20)
plot(ff,20*log10(abs(H1)),'b',ff,20*log10(abs(H2)),'r',ff,20*log10(abs(H3)),'g',ff,20*log10(abs(H4)),'m') ;
axis([0 fs/2 -70 0]);
%axis([0 500 -80 0]);
grid;

figure(21)
subplot(221)
zplane(b1,a1)

subplot(222)
zplane(b2,a2)

subplot(223)
zplane(b3,a3)

subplot(224)
zplane(b4,a4)


figure(22)
subplot(221)
impz(b1,a1,100)

subplot(222)
impz(b2,a2,100)

subplot(223)
impz(b3,a3,100)

subplot(224)
impz(b4,a4,100)


load speech_8_16_44.mat

if fs==44100,
    in=sig44;
    out=filter(b2,a2,in);
elseif fs==16000,
    in=sig16;
    out=filter(b2,a2,in);
elseif fs==8000,
    in=sig8;
    out=filter(b2,a2,in);
end

figure(30)
subplot(211); plot(in); title('Input signal')
subplot(212); plot(out); title('Output signal')

figure(31)
subplot(211); spectrogram(in,floor(fs*0.032),[],[],fs,'yaxis'); title('Input signal')
subplot(212); spectrogram(out,floor(fs*0.032),[],[],fs,'yaxis'); title('Output signal')


